#include "dsp.h"
#include "interface.h"
#define DDL_MAX 254;
//#define DEBUG 1
short ddlArray[255];
short recPos=0;
short playPos=1;
short input;
short DDL_SIZE;


void setup() {
#ifdef DEBUG
Serial.begin(9600); //debug
#endif
  int i;
  setupIO();
  for (i=0; i<DDL_SIZE; i++){
    ddlArray[i]=0;
  }
}

void nukebuf(){
 int i;
 digitalWrite(greenPin, HIGH);
 for (i=0; i< 254; i++){
    ddlArray[i]=0;  
 }
 digitalWrite(greenPin,LOW);
}

short prev, originalInput;
void loop() {
if(delayed > delayLength) {
  DDL_SIZE=analogRead(knobaPin)/4 ;
  if (DDL_SIZE < 30 ) { DDL_SIZE=30;}
  if(DDL_SIZE > 254 ){ DDL_SIZE = DDL_MAX;}
  if(analogRead(knobbPin)==0){ nukebuf();}
  input = analogRead(left);
  ddlArray[recPos]=input;
  output(left, ddlArray[playPos]);
  output(right, ddlArray[playPos]);
#ifdef DEBUG
/*
  Serial.print("recpos=");
  Serial.print(recPos);
    Serial.print(" recdat=");
  Serial.print(ddlArray[recPos]);

  Serial.print(" playPos=");
  Serial.print(playPos);
*/
// Serial.print(" playData=");
  Serial.println(ddlArray[playPos]);
#endif
  if (playPos==DDL_SIZE){
    playPos=0;
  } else {
    playPos++;
  }
  if (recPos==DDL_SIZE){
    recPos=0;
  } else {
    recPos++;    
  }  
  delayed = 0;
  }
  delayed++;
}

